<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');
include_once('/usr/www/include/SQLite2ToSQLite3.php');

/**
 * Implements the debug funtions of the gateway
 * @author Florian Kraatz <fk@beronet.com>
 * @author Miguel Palmer <mp@beronet.com>
 */
class FulltraceGui {

	private 	$_ba,
			$_bc,
			$_ft;

	private 	$m_attr;

	private		$action = 'default';

	private 	$isRequestRejected = 0,
			$reasonRejected = array();

        /**
         * Constructor
         */
        function __construct($m, $get = array(), $post = array(), $session = array()) {
		// load classes
		$this->_ba = new beroAri();
		$this->_bc = new beroConf('root');
		$this->_ft = new fulltrace();

		// set main GET variable
		$this->m_attr = $m;

		// get values from submit
		if (isset($get['error'])) {
			$this->isRequestRejected = 1;
			$this->reasonRejected = array('request' => $get['request'], 'checkor' => $get['checkor'], 'key' => $get['key']);
			unset($get['error'], $get['request'], $get['checkor'], $get['key']);
		}
		else if (isset($get['action'])) {
			$list_get = array('action' => 'select');
			$list_options = array(
				'action' => array('start', 'stop', 'default')
			);

			$is_safe = 1;
			$get = Helper::sanitizeGet($get, $list_get, $is_safe, $this->reasonRejected, $list_options);
			if ($is_safe) {
				$this->action = $get['action'];
			}
			else {
				$this->isRequestRejected = 1;
			}
			unset($get['action']);
		}
	}

	function show_network_ifs() {
		
		$ret = '<input type="checkbox" name="lan" id="lan" value="1" checked /><label for="lan">lan</label>&nbsp;&nbsp;';
		
		if ($this->_bc->get('root','lan-mode')=='lan-wan') {
			$ret  .= '<input type="checkbox" name="wan" id="wan" value="1"/><label for="wan">wan</label>';
		}
		return $ret;
	}
	// Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	function show_isdn_ports() {
		$select = '';
		$qu = $this->_ba->select('SELECT * FROM isdn');
		while ($entry = $this->_ba->fetch_array($qu)) {
			// Für jeden Port wird ein checkbox erzeugt
			$select .= '<input type="checkbox" name="ports[]" value="' . $entry['port'] . '" checked /><label for="ports[]">' . $entry['port'] . "</label>\n";
		}

		return($select);
	}

	private function _show_trace_run() {
		ob_start();
		?>
		<br />
		<form method="POST" class="form-horizontal" action='modules/FulltraceGui/fulltracegui_submit.php'>
			<p class="text-center lead" ><?php echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group text-center' id="ntphost">
				<img src="includes/images/punkt_gruen.gif" style="margin-right: 15px;">
				<input type="submit" class="btn btn-default" id="trace" name="trace" title="<?php echo DEBUG_CANCEL_TRACE; ?>" data-toggle="tooltip" value=<?php echo DEBUG_CANCEL_BUTTON_TEXT; ?> />
				<input type="submit" class="btn btn-default" id="trace" name="trace" title="<?php echo DEBUG_STOP_TRACE; ?>" data-toggle="tooltip" value="Stop" />
			</div>
		</form><br />
		<?php
		$ret .= ob_get_clean();

		// we don't display file-download during trace if we're not 'advanced'
		if (((strlen($this->_ba->get('gui_mode')) == 0) ? 'easy' : $this->_ba->get('gui_mode')) != 'advanced') {
			return($ret);
		}

		// get data
		foreach ($this->_ft->get_runtime_files() as $ftFile) {
			if (empty($ftFile)) {
				continue;
			}
			$ftFiles[] = array('name' => basename($ftFile), 'size' => filesize($ftFile));
			$fileName[] = basename($ftFile);
			$fileSize[] = filesize($ftFile);
		}

		// sort by file-size
		array_multisort($fileSize, SORT_DESC, $fileName, $ftFiles);

		// output
		ob_start();
		?>
		<hr>
		<p class="text-center lead" ><?php echo FULL_TRACE_SINGLE_TABLE_HEADER_DIS ?></p>
		<?php foreach ($ftFiles as $ftFile): ?>
			<form name="download_logfile" action="modules/FulltraceGui/isdn_trace.php?option=single_logfile" method="POST" class="form-horizontal">
				<div class='form-group' id="lan_netmask">
					<label for='logfile_name' class='col-sm-5 control-label'><?php echo $ftFile['name']; ?></label>
					<div class='col-sm-1'>
						<?php echo round(($ftFile['size'] / 1024), 2); ?> kB
					</div>
					<div class='col-sm-3'>
						<input type="hidden" name="logfile_name" value="<?php echo $ftFile['name']; ?>" />
						<input type="submit" class="btn btn-default" value="Download" />
					</div>
				</div>
			</form>
		<?php endforeach; ?>
		<hr>
		<?php
		$ret .= ob_get_clean();

		return($ret);
	}

	function table() {

		$colspan = 2;
		ob_start();

		$advanced_options="<input type='text' class='form-control' id='ft_advanced_options' name='ft_advanced_options' style='max-width:520px; min-width:300px;'>";
		
		$tech = ob_get_clean();
		
		$mode ="<div align=left> <input type='radio' name='fulltrace_type' id='fulltrace_basic' onclick='$(\"#advanced_fulltrace_settings\").hide();'  value='0' checked> ". FULL_TRACE_TYPE_BASIC ." <br>";
		$mode .="<input type='radio'  name='fulltrace_type' id='fulltrace_advanced' onclick='$(\"#advanced_fulltrace_settings\").show();' value='1'> ". FULL_TRACE_TYPE_ADVANCED ." <br> </div>";
		$html_str =	"<br/>
				<table class='table table-striped table-bordered' id='table' style='max-width:520px; min-width:300px; margin:auto; text-align: center;'>
				<tr>
				$table_td
				<td>
				$mode
				<div id='advanced_fulltrace_settings' align=left title='" . FULL_TRACE_TYPE_OPTPARAMETER_TT . "' data-toggle='tooltip'>
				<br/>
				". FULL_TRACE_TYPE_OPTPARAMETER ."<br>
				$advanced_options
				</div>
				</td>
				$td
				</tr>
				</table>";
		
		ob_start();
		?>
		<br/>
		<form method='POST' id='id-fulltrace-form' class="form-inline" action='modules/FulltraceGui/fulltracegui_submit.php'>
			<div style="display:table; margin: 0 auto;">
			<p class="text-center lead" ><?php echo FULL_TRACE_TABLE_HEADER_DIS ?></p>
			<div class='form-group' style="vertical-align: top;">
	
			</div>

			<?php echo $tech; ?>
			<?php echo $html_str; ?>
			</div>
			<br>
			<div class='text-center'>
				<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
				<input type='submit' class='btn btn-default' id='trace' name='trace' title="<?php echo DEBUG_START_TRACE; ?>" data-toggle="tooltip" 
					   value="<?php echo FULL_TRACE_BUTTON_START_DIS; ?>">
			</div>
		</form><br/>
		<script language='javascript'>
			window.onload = function() {
				document.getElementById('advanced_fulltrace_settings').style.display = 'none';
			}

			$('#id-fulltrace-form').validate({
				rules: {
					ft_advanced_options: {
						checkManual: true
					}
				},
			});	
		</script>
		<hr>
		<?php
		return ob_get_clean();
	}

	function display() {

		$name = 'FULL_TRACE_TITLE_DIS';
		include('./includes/header.php');
		require_once('./includes/isgwtelnet.php');
		
		if ($this->isRequestRejected) {
			$ret .= Helper::displayErrorMessage($this->reasonRejected['request'], $this->reasonRejected['checkor'], $this->reasonRejected['key']);
		}

		ob_start();
		?>
		<script language="javascript">
		    function checkallp() {
		        var checkall = document.getElementById('checkall');
		        var del = document.getElementsByName('ports[]');
		        if (checkall.checked == true) {
		            for (i = 0; i < del.length; i++) {
		                del[i].checked = true;
		            }
		        } else {
		            for (i = 0; i < del.length; i++) {
		                del[i].checked = false;
		            }
		        }
		    }

		    function dis() {
		        var isdn_enable = document.getElementById('isdn_enable');
		        var checkall = document.getElementById('checkall');
		        var del = document.getElementsByName('ports[]');
		        if (isdn_enable.checked == true) {
		            checkall.disabled = false;
		            for (i = 0; i < del.length; i++) {
		                del[i].disabled = false;
		            }
		        } else {
		            checkall.disabled = true;
		            for (i = 0; i < del.length; i++) {
		                del[i].disabled = true;
		            }
		        }
		    }
		</script>
		<?php
		$ret .= ob_get_clean();

		switch ($this->action) {
			case 'start':
				$ret .= $this->_show_trace_run();
				break;
			case 'stop':
				$ret .= $this->table();
				break;
			default:
				if ($this->_ba->get('trace') == 'yes') {
					$ret .= $this->_show_trace_run();
					break;
				}
				$ret .= $this->table();
				break;
		}
		/*
		  if (((strlen($this->_ba->get('trace')) == 0) || ($this->_ba->get('trace') == 'no')) && !isset($_POST['trace'])) {
		  $ret .= $this->table();
		  } elseif ($_POST['trace'] == 'Start' ) {

		  } else if ($_POST['trace'] == 'Stop') {
		  } else if ($this->_ba->get('trace') == 'yes') {
		  $ret .= $this->_show_trace_run();
		  }
		 */
		/*
		 * Überprüfung ob die dateien debug-info.tar.gz oder DebugFiles.tar.gz oder isgw.err,
		 * Wenn ja, wird einen Link für Download angeboten, und einen Link delete
		 * um die entsprechende Datei zu löschen
		 */
		if (file_exists("/var/log/debug-info.tar.gz") || file_exists("/var/log/DebugFiles.tar.gz") || file_exists("/var/log/isgw.err")) {
			ob_start();
			?>
			<form method='POST' class="form-horizontal">
				<p class="text-center lead" ><?php echo FULL_TRACE_DOWNLOADS_DIS ?></p>
				<?php if (file_exists("/var/log/debug-info.tar.gz")): ?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><?php echo FULL_TRACE_ISGW_COREDUMPS_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<?php echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=isgw';" 
								   title="<?php echo DEBUG_DOWNLOAD_TRACE; ?> " data-toggle='tooltip'>
							<input type='button' class='btn btn-default' value="<?php echo FULL_TRACE_BUTTON_DELETE_FILE_DIS; ?>" 
								   onclick="javascript:if (confirm('<?php echo FULL_TRACE_DELETE_COREDUMPS_DIS; ?>?') == true)
				                               window.location.href = 'misc/deletefile.php?m=<?php echo $this->m_attr; ?>&option=info';" 
								   title="<?php echo DEBUG_DELETE; ?>" data-toggle="tooltip">
						</div>
						<div class='col-sm-4'><?php echo date("d M Y H:i", filectime("/var/log/debug-info.tar.gz")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/DebugFiles.tar.gz")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><?php echo FULL_TRACE_DEBUG_FILES_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<?php echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php';" 
								   title="<?php echo DEBUG_DOWNLOAD_TRACE; ?> " data-toggle='tooltip'>
							<input type='button' class='btn btn-default' value="<?php echo FULL_TRACE_BUTTON_DELETE_FILE_DIS; ?>" 
								   onclick="javascript:if (confirm('<?php echo FULL_TRACE_DELETE_DEBUG_FILES_DIS; ?>?') == true)
				                               window.location.href = 'misc/deletefile.php?m=<?php echo $this->m_attr; ?>&option=debug';" 
								   title="<?php echo DEBUG_DELETE_FILES; ?>" data-toggle="tooltip">
						</div>
						<div class='col-sm-4'><?php echo date("d M Y H:i", filectime("/var/log/DebugFiles.tar.gz")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/isgw.err")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><?php echo FULL_TRACE_ERROR_LOG_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<?php echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=error';">
						</div>
						<div class='col-sm-4'><?php echo date("d M Y H:i", filectime("/var/log/isgw.err")); ?></div>
					</div>
					<?php
				endif;
				if (file_exists("/var/log/cloud.log")):
					?>
					<div class='form-group'>
						<label for='download' class='col-sm-4 control-label'><?php echo FULL_TRACE_CLOUD_LOG_DIS; ?></label>
						<div class='col-sm-3'>
							<input type='button' class='btn btn-default' value='<?php echo FULL_TRACE_BUTTON_DOWNLOAD_DIS ?>' 
								   onclick="window.location.href = 'modules/FulltraceGui/isdn_trace.php?option=cloud';">
						</div>
						<div class='col-sm-4'><?php echo date("d M Y H:i", filectime("/var/log/cloud.log")); ?></div>
					</div>
				<?php endif; ?>
			</form>
			<br/>
			<?php
			$ret .= ob_get_clean();
		}


		//Rückgabe: Der Inhalt von der HTML-Seite
		return $ret;
	}

}
?>
